﻿
Partial Class UserControl_Navegador
    Inherits System.Web.UI.UserControl

    Private p_TotalFilas As Integer = 0
    Private p_FilaActual As Integer = 0
    Private p_Navegacion As Boolean
    Public Event IndiceActual()



    Public Property TotalFilas() As Integer

        Get
            Return CType(ViewState("TotalFilas"), Integer)
        End Get

        Set(ByVal TotalRows As Integer)

            p_TotalFilas = TotalRows
            ViewState("TotalFilas") = p_TotalFilas

        End Set

    End Property

    Public Property FilaActual() As Integer

        Get
            Return CType(ViewState("FilaActual"), Integer)
        End Get

        Set(ByVal FilaActual As Integer)

            p_FilaActual = FilaActual

            If p_FilaActual < 0 Then
                p_FilaActual = 0
                ViewState("FilaActual") = p_FilaActual
            ElseIf p_FilaActual > CType(ViewState("TotalFilas"), Integer) Then
                p_FilaActual = CType(ViewState("TotalFilas"), Integer)
                ViewState("FilaActual") = p_FilaActual
            Else
                ViewState("FilaActual") = p_FilaActual
            End If

        End Set

    End Property


    Public Property Navegacion As Boolean
        Get
            p_Navegacion = CType(ViewState("navegacion"), Integer)
            Return p_Navegacion
        End Get
        Set(ByVal value As Boolean)
            If value = True Then

                p_Navegacion = True
                ViewState("navegacion") = p_Navegacion

                lkbPrimero.Enabled = True
                lkbPrimero.Text = "<i class='icon-double-angle-left icon-2'></i>"
                lkbPrimero.ForeColor = Drawing.Color.Black

                lkbAtras.Enabled = True
                lkbAtras.Text = "<i class='icon-angle-left icon-2'></i>"
                lkbAtras.ForeColor = Drawing.Color.Black

                lkbAdelante.Enabled = True
                lkbAdelante.Text = "<i class='icon-angle-right icon-2'></i>"
                lkbAdelante.ForeColor = Drawing.Color.Black

                lkbUltimo.Enabled = True
                lkbUltimo.Text = "<i class='icon-double-angle-right icon-2'></i>"
                lkbUltimo.ForeColor = Drawing.Color.Black

            Else

                p_Navegacion = False
                ViewState("navegacion") = p_Navegacion

                lkbPrimero.Enabled = False
                lkbPrimero.Text = "<i class='icon-muted icon-double-angle-left icon-2'></i>"

                lkbAtras.Enabled = False
                lkbAtras.Text = "<i class='icon-muted icon-angle-left icon-2'></i>"

                lkbAdelante.Enabled = False
                lkbAdelante.Text = "<i class='icon-muted icon-angle-right icon-2'></i>"

                lkbUltimo.Enabled = False
                lkbUltimo.Text = "<i class='icon-muted icon-double-angle-right icon-2'></i>"

            End If
        End Set
    End Property

    Protected Sub navegarIzquierda(sender As Object, e As EventArgs)
        p_FilaActual = CType(ViewState("FilaActual"), Integer) - 1
        ViewState("FilaActual") = p_FilaActual
        If p_FilaActual < 0 Then ' si es menor que cero asigno el maximo indice del array
            p_FilaActual = CType(ViewState("TotalFilas"), Integer)
            ViewState("FilaActual") = p_FilaActual
        End If

        RaiseEvent IndiceActual()
    End Sub

    Protected Sub navegarDerecha(sender As Object, e As EventArgs)
        p_FilaActual = CType(ViewState("FilaActual"), Integer) + 1
        ViewState("FilaActual") = p_FilaActual
        If p_FilaActual > CType(ViewState("TotalFilas"), Integer) Then
            p_FilaActual = 0
            ViewState("FilaActual") = p_FilaActual
        End If

        RaiseEvent IndiceActual()
    End Sub

    Protected Sub lkbPrimero_Click(ByVal sender As Object, ByVal e As EventArgs) Handles lkbPrimero.Click


        p_FilaActual = 0
        ViewState("FilaActual") = p_FilaActual

        RaiseEvent IndiceActual()

    End Sub

    Protected Sub lkbUltimo_Click(ByVal sender As Object, ByVal e As EventArgs) Handles lkbUltimo.Click

        p_FilaActual = CType(ViewState("TotalFilas"), Integer)
        ViewState("FilaActual") = p_FilaActual

        RaiseEvent IndiceActual()

    End Sub

    Protected Sub lkbAtras_Click(ByVal sender As Object, ByVal e As EventArgs) Handles lkbAtras.Click

        p_FilaActual = CType(ViewState("FilaActual"), Integer) - 1
        ViewState("FilaActual") = p_FilaActual
        If p_FilaActual < 0 Then ' si es menor que cero asigno el maximo indice del array
            p_FilaActual = CType(ViewState("TotalFilas"), Integer)
            ViewState("FilaActual") = p_FilaActual
        End If

        RaiseEvent IndiceActual()

    End Sub

    Protected Sub lkbAdelante_Click(ByVal sender As Object, ByVal e As EventArgs) Handles lkbAdelante.Click

        p_FilaActual = CType(ViewState("FilaActual"), Integer) + 1
        ViewState("FilaActual") = p_FilaActual
        If p_FilaActual > CType(ViewState("TotalFilas"), Integer) Then
            p_FilaActual = 0
            ViewState("FilaActual") = p_FilaActual
        End If

        RaiseEvent IndiceActual()

    End Sub

End Class
